package com.vdv.stuntcar;

public final class Road {

	static final int GROUND_Y = 512;
	static final int ROAD_WIDTH = 0x180;// 384
	static final int ROAD_SWING_CAR_POSITION = 160;
	static final int ROAD_POSITION_FOR_SPARKS = 0x100;// 384
	static final int OPPONENTS_START_ROAD_X_POOSITION = 0x4C;// 76
	/** halfway into piece */
	static final int OPPONENTS_START_DISTANCE_INTO_PIECE = 0x400;
	static final int WIDTH_REDUCTION = 65536 / (ROAD_WIDTH - 1);// 171
	static final int STEEP = 640;
	static final int TRACK_SKI_JUMP = 4;
	static final int TRACK_DRAW_BRIDGE = 5;
	static final int TRACK_ROLLER_COASTER = 7;

	// O2402	* Little Ramp
	static final byte[] LittleRamp = {

			44,// number.of.road.sections
			15,// players.start.section
			15,// near.start.line.section
			37,// half.a.lap.section

			(byte)0x00, (byte)0x05,// w_near_z_coord, w_near_x_coord 0x0500

			(byte)0xa0, (byte)0xcf, (byte)0x6a, (byte)0x9f, (byte)0x6b, (byte)0x24, (byte)0x50, (byte)0x50,
			(byte)0x25, (byte)0x00, (byte)0x00, (byte)0x19, (byte)0x63, (byte)0x80, (byte)0x2f, (byte)0x04, (byte)0x64, (byte)0x86, (byte)0x1f, (byte)0x65, (byte)0x66, (byte)0x57, (byte)0x0e, (byte)0x68,
			(byte)0x67, (byte)0xc0, (byte)0x0d, (byte)0x64, (byte)0x04, (byte)0xe0, (byte)0x0c, (byte)0x69, (byte)0x9f, (byte)0x17, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
			(byte)0x00, (byte)0x00, (byte)0xcc, (byte)0x02, (byte)0xc6, (byte)0x01, (byte)0x16, (byte)0x17, (byte)0xb7, (byte)0x10, (byte)0x00, (byte)0x01, (byte)0x20, (byte)0x19, (byte)0x18, (byte)0x94,
			(byte)0x31, (byte)0x04, (byte)0x03, (byte)0x2a, (byte)0x42, (byte)0x00, (byte)0x2a, (byte)0x53, (byte)0x00, (byte)0x2a, (byte)0x64, (byte)0x00, (byte)0x2a, (byte)0x75, (byte)0x28, (byte)0x2a,
			(byte)0x86, (byte)0x29, (byte)0x2a, (byte)0x97, (byte)0x00, (byte)0x2a, (byte)0xa8, (byte)0x2a, (byte)0x2a, (byte)0xb9, (byte)0x2b, (byte)0x2a, (byte)0xca, (byte)0x00, (byte)0x2a, (byte)0xdb,
			(byte)0x00, (byte)0x04, (byte)0xec, (byte)0x09, (byte)0x0a, (byte)0xd3, (byte)0xfd, (byte)0x16, (byte)0x17, (byte)0x66, (byte)0xfe, (byte)0x00, (byte)0x17, (byte)0xef, (byte)0x1b, (byte)0x1a,
			(byte)0x8d, (byte)0xdf,

			(byte)0x06,// standard_league_damage_limit
			(byte)0x05,// super_league_damage_limit
			(byte)0x22,// standard_league_boost
			(byte)0x2f,// super_league_boost
			(byte)0x02,// byte count to read into DAT_1c8a8 and DAT_1c8c8
			(byte)0x02,// byte count to read into DAT_1c8e8

			(byte)0x21, (byte)0x46,// DAT_1c8a8 and DAT_1c8c8, section numbers
			(byte)0x03, (byte)0x58,// DAT_1c8e8
			(byte)0x01, (byte)0x22
	};

	// O2526	* Stepping Stones
	static final byte[] SteppingStones = {
			56,
			42,
			42,
			14,

			(byte)0x00, (byte)0x0f,

			(byte)0xa0, (byte)0xcf, (byte)0x00, (byte)0x9f, (byte)0x3b, (byte)0x3c, (byte)0x3c, (byte)0x25, (byte)0x13, (byte)0x48, (byte)0x49, (byte)0x00,
			(byte)0x32, (byte)0x80, (byte)0x2f, (byte)0x04, (byte)0x64, (byte)0x86, (byte)0x1f, (byte)0x65, (byte)0x66, (byte)0x57, (byte)0x0e, (byte)0x68, (byte)0x67, (byte)0xc0, (byte)0x0d, (byte)0x64,
			(byte)0x04, (byte)0xe0, (byte)0x0c, (byte)0x69, (byte)0x9f, (byte)0x2e, (byte)0x2f, (byte)0x2e, (byte)0x2f, (byte)0x2e, (byte)0x2f, (byte)0x2e, (byte)0x2f, (byte)0x38, (byte)0xc0, (byte)0x02,
			(byte)0x4c, (byte)0x03, (byte)0xc6, (byte)0x01, (byte)0x7c, (byte)0x7d, (byte)0x97, (byte)0x10, (byte)0x7f, (byte)0x7e, (byte)0x00, (byte)0x20, (byte)0x03, (byte)0x4c, (byte)0x20, (byte)0x30,
			(byte)0x33, (byte)0x9f, (byte)0x33, (byte)0x15, (byte)0x1e, (byte)0x1f, (byte)0x64, (byte)0x64, (byte)0x64, (byte)0x64, (byte)0x5e, (byte)0x0c, (byte)0xd0, (byte)0x06, (byte)0xe0, (byte)0x16,
			(byte)0x17, (byte)0xd7, (byte)0xf1, (byte)0x1b, (byte)0x1a, (byte)0x4d, (byte)0xf2, (byte)0x60, (byte)0xf3, (byte)0x00, (byte)0x9f, (byte)0x00, (byte)0x49, (byte)0x00, (byte)0x5a, (byte)0x6b,
			(byte)0x00, (byte)0x00, (byte)0x48, (byte)0x00, (byte)0x4c, (byte)0xfd, (byte)0x46, (byte)0xfe, (byte)0x16, (byte)0x17, (byte)0x17, (byte)0xef, (byte)0x1b, (byte)0x1a, (byte)0x8d, (byte)0xdf,
			(byte)0x07, (byte)0x09, (byte)0x30, (byte)0x34, (byte)0x08, (byte)0x09, (byte)0x03, (byte)0xd4, (byte)0x08, (byte)0x3f, (byte)0x0f, (byte)0xbe, (byte)0x11, (byte)0xbd, (byte)0x13, (byte)0xbb,
			(byte)0x15, (byte)0xba, (byte)0x2c, (byte)0xf3, (byte)0x1e, (byte)0x42, (byte)0x10, (byte)0x11, (byte)0x12, (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16, (byte)0x2f, (byte)0x05
	};

	// O2671	* Hump Back
	static final byte[] HumpBack = {
			53,
			0x2e,
			0x2e,
			0x13,

			(byte)0x40, (byte)0x05,

			(byte)0x60, (byte)0x04, (byte)0x3a, (byte)0x8f, (byte)0x7a, (byte)0x1c, (byte)0x1d, (byte)0x1e, (byte)0x1f, (byte)0x22, (byte)0x27,
			(byte)0x43, (byte)0x4d, (byte)0x0d, (byte)0x47, (byte)0x0e, (byte)0x17, (byte)0x16, (byte)0x96, (byte)0x1f, (byte)0x1a, (byte)0x1b, (byte)0x0c, (byte)0x2f, (byte)0x20, (byte)0x3f, (byte)0x00,
			(byte)0x9f, (byte)0x48, (byte)0x00, (byte)0x39, (byte)0x00, (byte)0x48, (byte)0x49, (byte)0x48, (byte)0x00, (byte)0x38, (byte)0x00, (byte)0xdf, (byte)0x03, (byte)0x4c, (byte)0x07, (byte)0xef,
			(byte)0x7d, (byte)0x7c, (byte)0x56, (byte)0xfe, (byte)0x7e, (byte)0x7f, (byte)0xc0, (byte)0xfd, (byte)0x4c, (byte)0x03, (byte)0xe0, (byte)0xfc, (byte)0x33, (byte)0x6f, (byte)0x4a, (byte)0x71,
			(byte)0x1f, (byte)0x64, (byte)0x64, (byte)0x5e, (byte)0xcd, (byte)0xf5, (byte)0xc7, (byte)0xf4, (byte)0x17, (byte)0x16, (byte)0x16, (byte)0xe3, (byte)0x1a, (byte)0x1b, (byte)0x8c, (byte)0xd3,
			(byte)0xa0, (byte)0xc3, (byte)0x30, (byte)0x1f, (byte)0x4b, (byte)0x8c, (byte)0xa3, (byte)0x81, (byte)0x93, (byte)0x0b, (byte)0x0c, (byte)0x14, (byte)0x82, (byte)0x04, (byte)0x03, (byte)0x84,
			(byte)0x71, (byte)0x0a, (byte)0x09, (byte)0x11, (byte)0x60, (byte)0x0c, (byte)0x0b, (byte)0x8c, (byte)0x50, (byte)0xa0, (byte)0x40, (byte)0x00, (byte)0x1f, (byte)0x00, (byte)0x8d, (byte)0x20,
			(byte)0x87, (byte)0x10, (byte)0x17, (byte)0x16, (byte)0xd6, (byte)0x01, (byte)0x1a, (byte)0x1b, (byte)0x4c, (byte)0x02, (byte)0x60, (byte)0x03, (byte)0x00, (byte)0x06, (byte)0x05, (byte)0x29,
			(byte)0x31, (byte)0x06, (byte)0x01, (byte)0x00, (byte)0x52, (byte)0x01, (byte)0x4d, (byte)0x1b, (byte)0x4c, (byte)0x25, (byte)0x4f, (byte)0x28, (byte)0x4d, (byte)0x34, (byte)0x5c, (byte)0x26
	};

	// O2816	* Big Ramp
	static final byte[] BigRamp = {
			44,
			1,
			1,
			24,

			(byte)0x80, (byte)0x07,

			(byte)0xa0, (byte)0xc0, (byte)0x00, (byte)0x3f, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x80, (byte)0x80, (byte)0x6d,
			(byte)0x6e, (byte)0x4f, (byte)0x6e, (byte)0x6d, (byte)0x6d, (byte)0x6e, (byte)0x6e, (byte)0x6d, (byte)0x6d, (byte)0x6e, (byte)0xa0, (byte)0x30, (byte)0x00, (byte)0x8d, (byte)0x20, (byte)0x87,
			(byte)0x10, (byte)0x17, (byte)0x16, (byte)0xd6, (byte)0x01, (byte)0x1a, (byte)0x1b, (byte)0x4c, (byte)0x02, (byte)0x60, (byte)0x03, (byte)0x77, (byte)0x9f, (byte)0x29, (byte)0x00, (byte)0x00,
			(byte)0x76, (byte)0x40, (byte)0x29, (byte)0x00, (byte)0x00, (byte)0x45, (byte)0x4d, (byte)0x0d, (byte)0x47, (byte)0x0e, (byte)0x17, (byte)0x16, (byte)0xb6, (byte)0x1f, (byte)0x00, (byte)0x03,
			(byte)0x2f, (byte)0x18, (byte)0x19, (byte)0x54, (byte)0x3e, (byte)0x03, (byte)0x04, (byte)0xea, (byte)0x4d, (byte)0x31, (byte)0xea, (byte)0x5c, (byte)0x0d, (byte)0xea, (byte)0x6b, (byte)0x0d,
			(byte)0xea, (byte)0x7a, (byte)0x8e, (byte)0xea, (byte)0x89, (byte)0x00, (byte)0xea, (byte)0x98, (byte)0x00, (byte)0xea, (byte)0xa7, (byte)0x00, (byte)0xea, (byte)0xb6, (byte)0x90, (byte)0xea,
			(byte)0xc5, (byte)0x11, (byte)0xea, (byte)0xd4, (byte)0x59, (byte)0xc4, (byte)0xe3, (byte)0x0a, (byte)0x09, (byte)0x51, (byte)0xf2, (byte)0x17, (byte)0x16, (byte)0xe7, (byte)0xf1, (byte)0x00,
			(byte)0x16, (byte)0xe0, (byte)0x1a, (byte)0x1b, (byte)0x8c, (byte)0xd0, (byte)0x0a, (byte)0x09, (byte)0x2b, (byte)0x29, (byte)0x05, (byte)0x08, (byte)0x20, (byte)0xd6, (byte)0x0e, (byte)0x4e,
			(byte)0x0f, (byte)0x4b, (byte)0x13, (byte)0x4b, (byte)0x14, (byte)0x46, (byte)0x10, (byte)0x11, (byte)0x15, (byte)0x16, (byte)0x20, (byte)0x21, (byte)0x22, (byte)0x23
	};

	// O2958	* Ski Jump
	static final byte[] SkiJump = {
			40,
			15,
			15,
			35,

			(byte)0x40, (byte)0x6a,

			(byte)0xaa, (byte)0xbd, (byte)0x71, (byte)0xaa, (byte)0xac, (byte)0x21, (byte)0xaa, (byte)0x9b, (byte)0x64, (byte)0xaa, (byte)0x8a, (byte)0xcf,
			(byte)0xaa, (byte)0x79, (byte)0x00, (byte)0xaa, (byte)0x68, (byte)0x00, (byte)0xaa, (byte)0x57, (byte)0x00, (byte)0xaa, (byte)0x46, (byte)0x6f, (byte)0xaa, (byte)0x35, (byte)0xf2, (byte)0xaa,
			(byte)0x24, (byte)0x73, (byte)0x84, (byte)0x13, (byte)0x09, (byte)0x0a, (byte)0x53, (byte)0x02, (byte)0x16, (byte)0x17, (byte)0xe6, (byte)0x01, (byte)0x00, (byte)0x97, (byte)0x10, (byte)0x1b,
			(byte)0x1a, (byte)0x0d, (byte)0x20, (byte)0x20, (byte)0x30, (byte)0x24, (byte)0x00, (byte)0x40, (byte)0x50, (byte)0x33, (byte)0x01, (byte)0x50, (byte)0x52, (byte)0x53, (byte)0x94, (byte)0x61,
			(byte)0x33, (byte)0x50, (byte)0x2a, (byte)0x72, (byte)0x4c, (byte)0x04, (byte)0x83, (byte)0x55, (byte)0x54, (byte)0x91, (byte)0x94, (byte)0x53, (byte)0x52, (byte)0x00, (byte)0xa4, (byte)0x50,
			(byte)0x33, (byte)0x20, (byte)0xb4, (byte)0x4c, (byte)0x1f, (byte)0x25, (byte)0x0c, (byte)0xd4, (byte)0x06, (byte)0xe4, (byte)0x16, (byte)0x17, (byte)0xd7, (byte)0xf5, (byte)0x1b, (byte)0x1a,
			(byte)0x4d, (byte)0xf6, (byte)0x60, (byte)0xf7, (byte)0x4d, (byte)0x5f, (byte)0x47, (byte)0x7a, (byte)0x4e, (byte)0x7a, (byte)0x56, (byte)0x4c, (byte)0xfd, (byte)0x46, (byte)0xfe, (byte)0x16,
			(byte)0x17, (byte)0x37, (byte)0xef, (byte)0x00, (byte)0x81, (byte)0xdf, (byte)0x19, (byte)0x18, (byte)0x14, (byte)0xce, (byte)0x04, (byte)0x03, (byte)0x07, (byte)0x08, (byte)0x2b, (byte)0x28,
			(byte)0x06, (byte)0x01, (byte)0x03, (byte)0xd8, (byte)0x15, (byte)0x54, (byte)0x18, (byte)0x36, (byte)0x20, (byte)0xc2, (byte)0x00, (byte)0x42, (byte)0x27, (byte)0xc9, (byte)0x20
	};

	// O3103	* Draw Bridge
	static final byte[] DrawBridge = {
			78,
			42,
			42,
			4,

			(byte)0xa0, (byte)0x11,

			(byte)0xa0, (byte)0xcc, (byte)0x00, (byte)0x7f, (byte)0x38, (byte)0x33, (byte)0x33, (byte)0x2c, (byte)0x00, (byte)0x00, (byte)0x32,
			(byte)0x80, (byte)0x4c, (byte)0x04, (byte)0x64, (byte)0x86, (byte)0x3c, (byte)0x65, (byte)0x66, (byte)0x57, (byte)0x2b, (byte)0x68, (byte)0x67, (byte)0xc0, (byte)0x2a, (byte)0x64, (byte)0x04,
			(byte)0xe0, (byte)0x29, (byte)0x2b, (byte)0x3f, (byte)0x20, (byte)0x35, (byte)0x5c, (byte)0xc0, (byte)0x25, (byte)0x2d, (byte)0x0d, (byte)0xc6, (byte)0x24, (byte)0x57, (byte)0x47, (byte)0x97,
			(byte)0x33, (byte)0x5d, (byte)0x58, (byte)0x00, (byte)0x43, (byte)0x0d, (byte)0x2d, (byte)0x20, (byte)0x53, (byte)0x1c, (byte)0x3f, (byte)0x1d, (byte)0x3f, (byte)0x00, (byte)0x00, (byte)0x93,
			(byte)0x6d, (byte)0x6e, (byte)0x2f, (byte)0x6d, (byte)0x6e, (byte)0x6e, (byte)0x6d, (byte)0x20, (byte)0xc3, (byte)0x32, (byte)0x00, (byte)0xd3, (byte)0x64, (byte)0x04, (byte)0x07, (byte)0xe3,
			(byte)0x66, (byte)0x65, (byte)0x76, (byte)0xf2, (byte)0x70, (byte)0xe7, (byte)0xf1, (byte)0x70, (byte)0x16, (byte)0xe0, (byte)0x67, (byte)0x68, (byte)0x80, (byte)0xd0, (byte)0x04, (byte)0x64,
			(byte)0xa0, (byte)0xc0, (byte)0x70, (byte)0x9f, (byte)0x70, (byte)0x70, (byte)0x70, (byte)0xc2, (byte)0x00, (byte)0x64, (byte)0x64, (byte)0x2b, (byte)0x00, (byte)0x8d, (byte)0x20, (byte)0x87,
			(byte)0x10, (byte)0x17, (byte)0x16, (byte)0xd6, (byte)0x01, (byte)0x1a, (byte)0x1b, (byte)0x4c, (byte)0x02, (byte)0x60, (byte)0x03, (byte)0x00, (byte)0x9f, (byte)0x00, (byte)0x35, (byte)0xdf,
			(byte)0xe0, (byte)0x00, (byte)0xe1, (byte)0xe2, (byte)0x2b, (byte)0x38, (byte)0x40, (byte)0x0d, (byte)0x03, (byte)0x4c, (byte)0x47, (byte)0x0e, (byte)0x7d, (byte)0x7c, (byte)0x96, (byte)0x1f,
			(byte)0x7e, (byte)0x7f, (byte)0x00, (byte)0x2f, (byte)0x4c, (byte)0x03, (byte)0x20, (byte)0x3f, (byte)0x33, (byte)0x9f, (byte)0x33, (byte)0x33, (byte)0x15, (byte)0x1e, (byte)0x1f, (byte)0x22,
			(byte)0x44, (byte)0x64, (byte)0x5e, (byte)0x0d, (byte)0xdf, (byte)0x07, (byte)0xef, (byte)0x17, (byte)0x16, (byte)0x76, (byte)0xfe, (byte)0x00, (byte)0xe7, (byte)0xfd, (byte)0x00, (byte)0x16,
			(byte)0xec, (byte)0x1a, (byte)0x1b, (byte)0x8c, (byte)0xdc, (byte)0x04, (byte)0x04, (byte)0x48, (byte)0x48, (byte)0x09, (byte)0x07, (byte)0x03, (byte)0x62, (byte)0x06, (byte)0x55, (byte)0x07,
			(byte)0x50, (byte)0x14, (byte)0x43, (byte)0x3d, (byte)0xe4, (byte)0x41, (byte)0xd8, (byte)0x2d, (byte)0x5a, (byte)0x2e, (byte)0x50, (byte)0x2f, (byte)0xc6, (byte)0x04, (byte)0x0d, (byte)0x26,
			(byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36
	};

	// O3316	* High Jump
	static final byte[] HighJump = {
			52,
			29,
			29,
			4,

			(byte)0x40, (byte)0x06,

			(byte)0x20, (byte)0x3f, (byte)0x00, (byte)0x9f, (byte)0x00, (byte)0x3b,
			(byte)0x25, (byte)0x4d, (byte)0x3e, (byte)0x26, (byte)0x64, (byte)0x64, (byte)0x2b, (byte)0x0d, (byte)0xdf, (byte)0x07, (byte)0xef, (byte)0x17, (byte)0x16, (byte)0x56, (byte)0xfe, (byte)0x1a,
			(byte)0x1b, (byte)0xcc, (byte)0xfd, (byte)0xe0, (byte)0xfc, (byte)0x00, (byte)0x5f, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0xcd, (byte)0xf6, (byte)0xc3, (byte)0xf5,
			(byte)0x17, (byte)0x16, (byte)0x34, (byte)0xe4, (byte)0x00, (byte)0xaa, (byte)0xd3, (byte)0x00, (byte)0xaa, (byte)0xc2, (byte)0x00, (byte)0xa4, (byte)0xb1, (byte)0x00, (byte)0x11, (byte)0xa0,
			(byte)0x18, (byte)0x19, (byte)0x8c, (byte)0x90, (byte)0xa0, (byte)0x80, (byte)0x00, (byte)0x5f, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x8d, (byte)0x20, (byte)0x87,
			(byte)0x10, (byte)0x17, (byte)0x16, (byte)0xd6, (byte)0x01, (byte)0x1a, (byte)0x1b, (byte)0x4c, (byte)0x02, (byte)0x60, (byte)0x03, (byte)0x00, (byte)0x9f, (byte)0x3a, (byte)0x7a, (byte)0x36,
			(byte)0x00, (byte)0xb7, (byte)0x00, (byte)0x3d, (byte)0x27, (byte)0x43, (byte)0x4d, (byte)0x0d, (byte)0x47, (byte)0x0e, (byte)0x17, (byte)0x16, (byte)0x96, (byte)0x1f, (byte)0x1a, (byte)0x1b,
			(byte)0x0c, (byte)0x2f, (byte)0x06, (byte)0x06, (byte)0x2c, (byte)0x2a, (byte)0x06, (byte)0x0e, (byte)0x27, (byte)0xd3, (byte)0x28, (byte)0xce, (byte)0x02, (byte)0xd3, (byte)0x17, (byte)0x55,
			(byte)0x16, (byte)0x52, (byte)0x15, (byte)0x52, (byte)0x1e, (byte)0x1f, (byte)0x20, (byte)0x21, (byte)0x22, (byte)0x25, (byte)0x26, (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2a, (byte)0x2b,
			(byte)0x2c, (byte)0x2d
	};

	// O3458	* Roller Coaster
	static final byte[] RollerCoaster = {
			78,
			0,
			0,
			37,

			(byte)0x00, (byte)0x05,

			(byte)0xa0, (byte)0xcf, (byte)0x38, (byte)0x9f, (byte)0x01, (byte)0x82, (byte)0x82, (byte)0x82,
			(byte)0x82, (byte)0x82, (byte)0x07, (byte)0x4a, (byte)0x00, (byte)0x8c, (byte)0x2f, (byte)0x86, (byte)0x1f, (byte)0x16, (byte)0x17, (byte)0x57, (byte)0x0e, (byte)0x1b, (byte)0x1a, (byte)0xcd,
			(byte)0x0d, (byte)0xe0, (byte)0x0c, (byte)0x19, (byte)0x9f, (byte)0x08, (byte)0x0f, (byte)0xf5, (byte)0xf5, (byte)0xf5, (byte)0xf5, (byte)0x6c, (byte)0x74, (byte)0x5c, (byte)0xc0, (byte)0x02,
			(byte)0x2d, (byte)0x0d, (byte)0xc6, (byte)0x01, (byte)0x57, (byte)0x47, (byte)0x97, (byte)0x10, (byte)0x5d, (byte)0x58, (byte)0x00, (byte)0x20, (byte)0x0d, (byte)0x2d, (byte)0x20, (byte)0x30,
			(byte)0x1c, (byte)0x9f, (byte)0x1d, (byte)0x1e, (byte)0x1f, (byte)0x22, (byte)0x27, (byte)0x27, (byte)0x27, (byte)0x43, (byte)0x38, (byte)0x00, (byte)0xd0, (byte)0x4c, (byte)0x03, (byte)0x06,
			(byte)0xe0, (byte)0x05, (byte)0x06, (byte)0xf7, (byte)0xf1, (byte)0x34, (byte)0x66, (byte)0xf2, (byte)0x41, (byte)0x17, (byte)0xe3, (byte)0x12, (byte)0x14, (byte)0x80, (byte)0xd3, (byte)0x64,
			(byte)0x04, (byte)0xa0, (byte)0xc3, (byte)0x70, (byte)0x7f, (byte)0x4b, (byte)0x35, (byte)0x33, (byte)0x33, (byte)0x33, (byte)0x33, (byte)0x33, (byte)0x80, (byte)0x43, (byte)0x03, (byte)0x4c,
			(byte)0x87, (byte)0x33, (byte)0x06, (byte)0x05, (byte)0xf6, (byte)0x24, (byte)0x34, (byte)0x67, (byte)0x25, (byte)0x00, (byte)0x96, (byte)0x36, (byte)0x1a, (byte)0x1b, (byte)0x0c, (byte)0x46,
			(byte)0x20, (byte)0x56, (byte)0x00, (byte)0x7f, (byte)0x23, (byte)0x5b, (byte)0x70, (byte)0x70, (byte)0x70, (byte)0x70, (byte)0x70, (byte)0x00, (byte)0xd6, (byte)0x04, (byte)0x64, (byte)0x06,
			(byte)0xe6, (byte)0x65, (byte)0x66, (byte)0xd7, (byte)0xf7, (byte)0x68, (byte)0x67, (byte)0x40, (byte)0xf8, (byte)0x64, (byte)0x04, (byte)0x60, (byte)0xf9, (byte)0x2b, (byte)0x3f, (byte)0x00,
			(byte)0x00, (byte)0x00, (byte)0x4c, (byte)0xfd, (byte)0x46, (byte)0xfe, (byte)0x16, (byte)0x17, (byte)0x17, (byte)0xef, (byte)0x1b, (byte)0x1a, (byte)0x8d, (byte)0xdf, (byte)0x03, (byte)0x03,
			(byte)0x50, (byte)0x59, (byte)0x07, (byte)0x00, (byte)0x06, (byte)0x2a, (byte)0x07, (byte)0x29, (byte)0x0e, (byte)0x36, (byte)0x1a, (byte)0x54, (byte)0x1b, (byte)0x4a, (byte)0x4d, (byte)0x52,
			(byte)0x4c, (byte)0x5a, (byte)0xfe, (byte)0x04, (byte)0xbd, (byte)0xff, (byte)0x04, (byte)0x84, (byte)0x0b, (byte)0x85, (byte)0x0c, (byte)0x20, (byte)0x77, (byte)0x98, (byte)0x4c, (byte)0xa3,
			(byte)0x8b, (byte)0xa5, (byte)0x26, (byte)0x38, (byte)0xe9, (byte)0x0f, (byte)0x85, (byte)0x26, (byte)0xa4, (byte)0x1b, (byte)0x84, (byte)0x0a, (byte)0x20, (byte)0x97, (byte)0x8a, (byte)0xc9,
			(byte)0x2c, (byte)0xd0, (byte)0x3e, (byte)0x4c, (byte)0x95, (byte)0xb6, (byte)0x20, (byte)0x54, (byte)0xb3, (byte)0xa5, (byte)0x26, (byte)0x18, (byte)0x69, (byte)0xf4, (byte)0x85, (byte)0x4b,
			(byte)0xa9, (byte)0x05, (byte)0x85, (byte)0x4c, (byte)0x20, (byte)0x00, (byte)0xa5, (byte)0xa5, (byte)0x2a, (byte)0x85, (byte)0x37, (byte)0xa5, (byte)0x2b, (byte)0x85, (byte)0x38, (byte)0x20,
			(byte)0xe9, (byte)0xb4, (byte)0xa5, (byte)0x26, (byte)0x85, (byte)0x27, (byte)0x18, (byte)0x69, (byte)0xf9, (byte)0x85, (byte)0x4b, (byte)0xa9, (byte)0x05, (byte)0x85, (byte)0x4c, (byte)0x20,
			(byte)0x5f, (byte)0x9a, (byte)0xf0, (byte)0xad, (byte)0xbd, (byte)0xf5, (byte)0x04, (byte)0x30, (byte)0x04, (byte)0xb0, (byte)0xa6, (byte)0x90, (byte)0xb4, (byte)0x90, (byte)0xa2, (byte)0xb0,
			(byte)0xb0, (byte)0x4c, (byte)0x96, (byte)0x8b, (byte)0x00, (byte)0x22, (byte)0xe3, (byte)0x20, (byte)0x76, (byte)0x61
	};

	// road_data_offsets
	/**
	 * These words give the following offsets:
	 * <p>
	 * 2402,2526,2671,2816,2958,3103,3316,3458
	 * 0000,0000,0000,0000,0000,0000,0000,0000
	 */
	/* static final short[] road_data_offsets = {
			0x62ba, (short) 0xdeba, 0x6fbb, 0x00bc, (short) 0x8ebc, 0x1fbd, (short) 0xf4bd, (short) 0x82be,
			(short) 0xf5a7, 0x4c00, (short) 0xa54c, (short) 0xb2a3, 0x0017, 0x4163, 0x6375, 0x7261
	}; */

	static final byte[][] road_data_offsets = {
			LittleRamp, SteppingStones,
			HumpBack, BigRamp,
			SkiJump, DrawBridge,
			HighJump, RollerCoaster
		};
	static final int PIECE_1 = 1;
	static final int PIECE_3 = 3;
	static final int PIECE_4 = 4;
	static final int PIECE_10 = 10;

	// O336
	static final byte[] piece1 = {
			4,// offset for number.of.coords
			0,// near.section.type
			0x40, 0x03,
			9*2,// number of coordinate pairs x2 or sections x 2
			0,// curve flags
			(byte)WIDTH_REDUCTION,// road.width.reduction
			(byte)128,// road.length.reduction
			(byte)0x80, (byte)0x01,
			(byte)0x20,// section.steering.amount

			// Groups of X and Z coordinates follow. There are two bytes for each
			// coordinate - stored in low byte, high byte order.
			// 72 bytes, 36 coordinates, 18 coordinate pairs, 9 segments, 8 sections
			// First line is :-	X = 0x340, Z = 0x000, X = 0x4c0, Z = 0x000
			0x40, (byte)0x03, (byte)0x00, (byte)0x00, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x00,// straight 8
			0x40, (byte)0x03, (byte)0x00, (byte)0x01, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x01,
			0x40, (byte)0x03, (byte)0x00, (byte)0x02, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x02,
			0x40, (byte)0x03, (byte)0x00, (byte)0x03, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x03,
			0x40, (byte)0x03, (byte)0x00, (byte)0x04, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x04,
			0x40, (byte)0x03, (byte)0x00, (byte)0x05, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x05,
			0x40, (byte)0x03, (byte)0x00, (byte)0x06, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x06,
			0x40, (byte)0x03, (byte)0x00, (byte)0x07, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x07,
			0x40, (byte)0x03, (byte)0x00, (byte)0x08, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x08,
		};

	//O419
	static final byte[] piece2 = {
			12,
			(byte)0x80,
			(byte)0xa8, (byte)0x0d, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0xff, (byte)0x80, (byte)0x68, (byte)0x0a, (byte)0x87,
			9*2,
			0,
			(byte)WIDTH_REDUCTION,
			(byte)135,
			(byte)0x80, (byte)0x01,
			(byte)0x3e,

			(byte)0x40, (byte)0x03, (byte)0x00, (byte)0x00, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x00,// curve right 8
			(byte)0x4c, (byte)0x03, (byte)0x05, (byte)0x01, (byte)0xca, (byte)0x04, (byte)0xdf, (byte)0x00,
			(byte)0x73, (byte)0x03, (byte)0x07, (byte)0x02, (byte)0xeb, (byte)0x04, (byte)0xbc, (byte)0x01,
			(byte)0xb2, (byte)0x03, (byte)0x05, (byte)0x03, (byte)0x22, (byte)0x05, (byte)0x95, (byte)0x02,
			(byte)0x0a, (byte)0x04, (byte)0xfb, (byte)0x03, (byte)0x6d, (byte)0x05, (byte)0x68, (byte)0x03,
			(byte)0x7a, (byte)0x04, (byte)0xe7, (byte)0x04, (byte)0xcd, (byte)0x05, (byte)0x32, (byte)0x04,
			(byte)0x00, (byte)0x05, (byte)0xc8, (byte)0x05, (byte)0x40, (byte)0x06, (byte)0xf2, (byte)0x04,
			(byte)0x9c, (byte)0x05, (byte)0x9a, (byte)0x06, (byte)0xc5, (byte)0x06, (byte)0xa6, (byte)0x05,
			(byte)0x4c, (byte)0x06, (byte)0x5b, (byte)0x07, (byte)0x5b, (byte)0x07, (byte)0x4c, (byte)0x06,
	};
	
	// O510
	static final byte[] piece3 = {
			(byte)12,
			(byte)0xc0,
			(byte)0x57, (byte)0xfa, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x01, (byte)0x80, (byte)0xe8, (byte)0x08, (byte)0x87,
			(byte)9*2,
			(byte)3,
			(byte)WIDTH_REDUCTION,
			(byte)135,
			(byte)0x80, (byte)0x01,
			(byte)0x3e,

			(byte)0x3f, (byte)0x03, (byte)0x00, (byte)0x00, (byte)0xbf, (byte)0x04, (byte)0x00, (byte)0x00,// curve left 8
			(byte)0x35, (byte)0x03, (byte)0xdf, (byte)0x00, (byte)0xb3, (byte)0x04, (byte)0x05, (byte)0x01,
			(byte)0x14, (byte)0x03, (byte)0xbc, (byte)0x01, (byte)0x8c, (byte)0x04, (byte)0x07, (byte)0x02,
			(byte)0xdd, (byte)0x02, (byte)0x95, (byte)0x02, (byte)0x4d, (byte)0x04, (byte)0x05, (byte)0x03,
			(byte)0x92, (byte)0x02, (byte)0x68, (byte)0x03, (byte)0xf5, (byte)0x03, (byte)0xfb, (byte)0x03,
			(byte)0x32, (byte)0x02, (byte)0x32, (byte)0x04, (byte)0x85, (byte)0x03, (byte)0xe7, (byte)0x04,
			(byte)0xbf, (byte)0x01, (byte)0xf2, (byte)0x04, (byte)0xff, (byte)0x02, (byte)0xc8, (byte)0x05,
			(byte)0x3a, (byte)0x01, (byte)0xa6, (byte)0x05, (byte)0x63, (byte)0x02, (byte)0x9a, (byte)0x06,
			(byte)0xa4, (byte)0x00, (byte)0x4c, (byte)0x06, (byte)0xb3, (byte)0x01, (byte)0x5b, (byte)0x07
		};

	// O601
	static final byte[] piece4 = {
			(byte)8,
			(byte)0x40,
			(byte)0x40, (byte)0xff, (byte)0x00, (byte)0x20, (byte)0x80, (byte)0xb5,
			(byte)14*2,
			(byte)0,
			(byte)WIDTH_REDUCTION,
			(byte)128,
			(byte)0x80, (byte)0x01,
			(byte)0x20,

			(byte)0x78, (byte)0xff, (byte)0x87, (byte)0x00, (byte)0x87, (byte)0x00, (byte)0x78, (byte)0xff,// straight 13
			(byte)0x2c, (byte)0x00, (byte)0x3c, (byte)0x01, (byte)0x3c, (byte)0x01, (byte)0x2c, (byte)0x00,
			(byte)0xe1, (byte)0x00, (byte)0xf0, (byte)0x01, (byte)0xf0, (byte)0x01, (byte)0xe1, (byte)0x00,
			(byte)0x96, (byte)0x01, (byte)0xa5, (byte)0x02, (byte)0xa5, (byte)0x02, (byte)0x96, (byte)0x01,
			(byte)0x4a, (byte)0x02, (byte)0x5a, (byte)0x03, (byte)0x5a, (byte)0x03, (byte)0x4a, (byte)0x02,
			(byte)0xff, (byte)0x02, (byte)0x0e, (byte)0x04, (byte)0x0e, (byte)0x04, (byte)0xff, (byte)0x02,
			(byte)0xb3, (byte)0x03, (byte)0xc3, (byte)0x04, (byte)0xc3, (byte)0x04, (byte)0xb3, (byte)0x03,
			(byte)0x68, (byte)0x04, (byte)0x77, (byte)0x05, (byte)0x77, (byte)0x05, (byte)0x68, (byte)0x04,
			(byte)0x1d, (byte)0x05, (byte)0x2c, (byte)0x06, (byte)0x2c, (byte)0x06, (byte)0x1d, (byte)0x05,
			(byte)0xd1, (byte)0x05, (byte)0xe1, (byte)0x06, (byte)0xe1, (byte)0x06, (byte)0xd1, (byte)0x05,
			(byte)0x86, (byte)0x06, (byte)0x95, (byte)0x07, (byte)0x95, (byte)0x07, (byte)0x86, (byte)0x06,
			(byte)0x3a, (byte)0x07, (byte)0x4a, (byte)0x08, (byte)0x4a, (byte)0x08, (byte)0x3a, (byte)0x07,
			(byte)0xef, (byte)0x07, (byte)0xff, (byte)0x08, (byte)0xff, (byte)0x08, (byte)0xef, (byte)0x07,
			(byte)0xa4, (byte)0x08, (byte)0xb3, (byte)0x09, (byte)0xb3, (byte)0x09, (byte)0xa4, (byte)0x08
		};

	// O728
	static final byte[] piece5 = {
			(byte)12,
			(byte)0x80,
			(byte)0x00, (byte)0x10, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0xff, (byte)0x90, (byte)0xc0, (byte)0x0c, (byte)0x7a,
			(byte)10*2,
			(byte)0,
			(byte)WIDTH_REDUCTION,
			(byte)122,
			(byte)0x80, (byte)0x01,
			(byte)0x32,
			// +19
			(byte)0x40, (byte)0x03, (byte)0x00, (byte)0x00, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x00,// curve right 9
			(byte)0x4c, (byte)0x03, (byte)0x1c, (byte)0x01, (byte)0xca, (byte)0x04, (byte)0xfb, (byte)0x00,
			(byte)0x71, (byte)0x03, (byte)0x36, (byte)0x02, (byte)0xeb, (byte)0x04, (byte)0xf4, (byte)0x01,
			(byte)0xaf, (byte)0x03, (byte)0x4c, (byte)0x03, (byte)0x22, (byte)0x05, (byte)0xe9, (byte)0x02,
			(byte)0x04, (byte)0x04, (byte)0x5c, (byte)0x04, (byte)0x6d, (byte)0x05, (byte)0xd9, (byte)0x03,
			(byte)0x71, (byte)0x04, (byte)0x63, (byte)0x05, (byte)0xcd, (byte)0x05, (byte)0xc1, (byte)0x04,
			(byte)0xf5, (byte)0x04, (byte)0x60, (byte)0x06, (byte)0x41, (byte)0x06, (byte)0xa0, (byte)0x05,
			(byte)0x8e, (byte)0x05, (byte)0x50, (byte)0x07, (byte)0xc8, (byte)0x06, (byte)0x73, (byte)0x06,
			(byte)0x3b, (byte)0x06, (byte)0x32, (byte)0x08, (byte)0x61, (byte)0x07, (byte)0x3b, (byte)0x07,
			(byte)0xfc, (byte)0x06, (byte)0x03, (byte)0x09, (byte)0x0b, (byte)0x08, (byte)0xf4, (byte)0x07
		};

	// O827
	static final byte[] piece6 = {
			(byte)12,
			(byte)0xc0,
			(byte)0x00, (byte)0xf8, (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x01, (byte)0x90, (byte)0x40, (byte)0x0b, (byte)0x7a,
			(byte)10*2,
			(byte)3,
			(byte)WIDTH_REDUCTION,
			(byte)122,
			(byte)0x80, (byte)0x01,
			(byte)0x32,

			(byte)0x40, (byte)0x03, (byte)0x00, (byte)0x00, (byte)0xc0, (byte)0x04, (byte)0x00, (byte)0x00,// curve left 9
			(byte)0x35, (byte)0x03, (byte)0xfb, (byte)0x00, (byte)0xb3, (byte)0x04, (byte)0x1c, (byte)0x01,
			(byte)0x14, (byte)0x03, (byte)0xf4, (byte)0x01, (byte)0x8e, (byte)0x04, (byte)0x36, (byte)0x02,
			(byte)0xdd, (byte)0x02, (byte)0xe9, (byte)0x02, (byte)0x50, (byte)0x04, (byte)0x4c, (byte)0x03,
			(byte)0x92, (byte)0x02, (byte)0xd9, (byte)0x03, (byte)0xfb, (byte)0x03, (byte)0x5c, (byte)0x04,
			(byte)0x32, (byte)0x02, (byte)0xc1, (byte)0x04, (byte)0x8e, (byte)0x03, (byte)0x63, (byte)0x05,
			(byte)0xbe, (byte)0x01, (byte)0xa0, (byte)0x05, (byte)0x0a, (byte)0x03, (byte)0x60, (byte)0x06,
			(byte)0x37, (byte)0x01, (byte)0x73, (byte)0x06, (byte)0x71, (byte)0x02, (byte)0x50, (byte)0x07,
			(byte)0x9e, (byte)0x00, (byte)0x3b, (byte)0x07, (byte)0xc4, (byte)0x01, (byte)0x32, (byte)0x08,
			(byte)0xf4, (byte)0xff, (byte)0xf4, (byte)0x07, (byte)0x03, (byte)0x01, (byte)0x03, (byte)0x09
		};

	// O926
	static final byte[] piece7 = {
			(byte)8,
			(byte)0x40,
			(byte)0x40, (byte)0xff, (byte)0x00, (byte)0x20, (byte)0x7c, (byte)0xb0,
			(byte)12*2,
			(byte)0,
			(byte)WIDTH_REDUCTION,
			(byte)124,
			(byte)0x80, (byte)0x01,
			(byte)0x20,

			(byte)0x78, (byte)0xff, (byte)0x87, (byte)0x00, (byte)0x87, (byte)0x00, (byte)0x78, (byte)0xff,// straight 11
			(byte)0x32, (byte)0x00, (byte)0x41, (byte)0x01, (byte)0x41, (byte)0x01, (byte)0x32, (byte)0x00,
			(byte)0xec, (byte)0x00, (byte)0xfc, (byte)0x01, (byte)0xfc, (byte)0x01, (byte)0xec, (byte)0x00,
			(byte)0xa6, (byte)0x01, (byte)0xb6, (byte)0x02, (byte)0xb6, (byte)0x02, (byte)0xa6, (byte)0x01,
			(byte)0x60, (byte)0x02, (byte)0x70, (byte)0x03, (byte)0x70, (byte)0x03, (byte)0x60, (byte)0x02,
			(byte)0x1b, (byte)0x03, (byte)0x2a, (byte)0x04, (byte)0x2a, (byte)0x04, (byte)0x1b, (byte)0x03,
			(byte)0xd5, (byte)0x03, (byte)0xe4, (byte)0x04, (byte)0xe4, (byte)0x04, (byte)0xd5, (byte)0x03,
			(byte)0x8f, (byte)0x04, (byte)0x9f, (byte)0x05, (byte)0x9f, (byte)0x05, (byte)0x8f, (byte)0x04,
			(byte)0x49, (byte)0x05, (byte)0x59, (byte)0x06, (byte)0x59, (byte)0x06, (byte)0x49, (byte)0x05,
			(byte)0x03, (byte)0x06, (byte)0x13, (byte)0x07, (byte)0x13, (byte)0x07, (byte)0x03, (byte)0x06,
			(byte)0xbe, (byte)0x06, (byte)0xcd, (byte)0x07, (byte)0xcd, (byte)0x07, (byte)0xbe, (byte)0x06,
			(byte)0x78, (byte)0x07, (byte)0x87, (byte)0x08, (byte)0x87, (byte)0x08, (byte)0x78, (byte)0x07
		};

	// piece.data.offsets
	/** These first 16 words are used to give offsets to the data definitions of
	 * the different road pieces.  They are stored in low byte, high byte order,
	 * so they are rotated by 8 bit positions to give a high byte, low byte word.
	 * This word then has #0xb100 subtracted from it to give an offset to the data
	 * of the required piece.
	 *
	 * The resulting words are as follows :-
	 *
	 *	336,419,000,510,601,000,728,827
	 *	000,000,926,000,000,000,000,000
	 *
	 * Some values have been replaced by zeros because the actual values are
	 * bollocks and are not used by the program (for any of the roads).  The only
	 * values used by the program are words 0, 1, 3, 4, 6, 7 and 10.
	 */
	/* static final short[] w_piece_data_offsets = {
			0x50b2, (short)0xa3b2, (short)0xa9ff, (short)0xfeb2, 0x59b3, 0x20da, (short)0xd8b3, 0x3bb4,
			0x0a46, 0x2e20, (short)0x9eb4, (short)0xa980, (short)0x852e, 0x60a5, 0x30c9, (short)0x8190
	}; */
	static final byte[][] w_piece_data_offsets = {
			piece1, piece2, null, piece3, piece4, null, piece5, piece6,
			null, null, piece7, null, null, null, null, null
	};

	static final byte[] b_TAB_5b2c4 = { 3, 4, 4, 3 };

	// sections.car.can.be.put.on
	/**
	 * These 16 bytes are flags for each of the near sections.  The actual values
	 * used are as follows :-
	 *
	 * dc.b	 (byte) 0x00, (byte) 0x80, (byte) 0x00, (byte) 0xc0, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0xc0
	 * dc.b	 (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00
	 *
	 * If bit 7 is set then the car cannot be lowered onto this section.
	 */
	static final byte[] sections_car_can_be_put_on = {
			0x00, (byte)0x80, 0x20, (byte)0xc0, 0x00, 0x73, (byte)0x80, (byte)0xc0,
			(byte)0xa9, 0x59, 0x00, 0x02, (byte)0xa9, 0x5e, (byte)0x85, 0x4b
		};

	// opponent max speed linked values
	// DAT.1fe2c
	static final byte[] opponents_speed_data = {
			// columns: tracks by id
			// Standard league
			0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,// speed variation for track
			0x41, 0x3a, 0x3e, 0x41, 0x48, 0x51, 0x48, 0x4f,// min speed
			// used when creating opponents_speed_values
			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,// variation
			0x48, 0x41, 0x45, 0x48, 0x4f, 0x58, 0x4f, 0x56,// min value

			// Super league
			0x07, 0x03, 0x03, 0x03, 0x03, 0x03, 0x07, 0x03,// speed variation for track
			0x66, 0x57, 0x57, 0x59, 0x59, 0x69, 0x62, 0x64,// min speed
			// used when creating opponents_speed_values
			0x07, 0x03, 0x03, 0x03, 0x03, 0x01, 0x03, 0x03,// variation
			0x61, 0x55, 0x53, 0x56, 0x58, 0x5b, 0x5a, 0x62// min value
	};

	// TAB.65e30
	/**
	 * bytes are paired. < 0 means end of data.
	 * road_visible_range_table[ i ] = data[ i + i ]
	 */
	static final byte[] b_default_visible_range_for_tracks = {
			// track 0, no information
			(byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			// track 1, no information
			(byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			// track 2
			0x30, 0x18, (byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
			// track 3, no information
			(byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			// track 4
			0x1a, 0x18, (byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
			// track 5
			0x0f, 0x28, 0x1c, 0x28, (byte)0x80, 0x00, 0x00, 0x00,
			// track 6, no information
			(byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
			// track 7
			0x3d, 0x30, (byte)0x80, 0x00, 0x00, 0x00, 0x00, 0x00
	};
	
	/******** Start of y co-ordinates for near sections ********
	 *
	 * B means co-ords are stored as bytes, W means words.
	 * Flag 0x80 means use a coordinate pair for far road coordinates
	 */
	static final byte[][] w_y_coordinate_offsets = {
			// 0 static final byte[] B1037 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1051 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x61, (byte) 0x03, (byte) 0x44, (byte) 0x26, (byte) 0x28, (byte) 0x2a, (byte) 0x2c },

			// static final char[] W1060 =
			// new char[] { 0x0000, 0x0200, 0x0400, 0x0600, 0x0800, 0x0a00, 0x0c00, 0x0e00, 0x1000 },
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x02, (byte) 0x00, (byte) 0x04, (byte) 0x00, (byte) 0x06, (byte) 0x00, (byte) 0x08, (byte) 0x00, (byte) 0x0a, (byte) 0x00, (byte) 0x0c, (byte) 0x00, (byte) 0x0e, (byte) 0x00, (byte) 0x10, (byte) 0x00},

			// static final byte[] B1078 =
			new byte[] { (byte) 0x00, (byte) 0x20, (byte) 0x40, (byte) 0x60, (byte) 0x01, (byte) 0x21, (byte) 0x41, (byte) 0x61, (byte) 0x02, (byte) 0x02, (byte) 0x02, (byte) 0x02, (byte) 0x02, (byte) 0x02 },

			// static final byte[] B1092 =
			new byte[] { (byte) 0x02, (byte) 0x61, (byte) 0x41, (byte) 0x21, (byte) 0x01, (byte) 0x60, (byte) 0x40, (byte) 0x20, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// 5 static final byte[] B1106 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x21, (byte) 0x51, (byte) 0x02, (byte) 0x22, (byte) 0x42, (byte) 0x62, (byte) 0x03, (byte) 0x13 },

			// static final byte[] B1116 =
			new byte[] { (byte) 0x00, (byte) 0x20, (byte) 0x40, (byte) 0x70, (byte) 0x21, (byte) 0x41, (byte) 0x61, (byte) 0x02, (byte) 0x22, (byte) 0x32 },

			// static final byte[] B1126 =
			new byte[] { (byte) 0x00, (byte) 0x02, (byte) 0x04, (byte) 0x06, (byte) 0xe7, (byte) 0x29, (byte) 0xca, (byte) 0x4b, (byte) 0x2c },

			// static final byte[] B1135 =
			new byte[] { (byte) 0x46, (byte) 0x96, (byte) 0x55, (byte) 0x85, (byte) 0x24, (byte) 0x33, (byte) 0xb2, (byte) 0x21, (byte) 0x00 },

			// 9 static final byte[] B1144 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x20, (byte) 0x40, (byte) 0x60, (byte) 0x01, (byte) 0x21, (byte) 0x41, (byte) 0x61, (byte) 0x02 },

			// 10 static final byte[] B1158 =
			new byte[] { (byte) 0x02, (byte) 0x02, (byte) 0x02, (byte) 0x02, (byte) 0x02, (byte) 0x71, (byte) 0x61, (byte) 0x41, (byte) 0x21, (byte) 0x01, (byte) 0x60, (byte) 0x40, (byte) 0x20, (byte) 0x00 },

			// static final byte[] B1172 =
			new byte[] { (byte) 0x00, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x10, (byte) 0x90, (byte) 0x80 },

			// static final byte[] B1181 =
			new byte[] { (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x90 },

			// static final byte[] B1190 =
			new byte[] { (byte) 0x00, (byte) 0x01, (byte) 0x02, (byte) 0x03, (byte) 0x04, (byte) 0x05, (byte) 0x06, (byte) 0x07, (byte) 0x08, (byte) 0x09, (byte) 0x0a, (byte) 0x0b },

			// static final char[] W1202 =
			// new char[] { 0x1b80, 0x1c80, 0x1d80, 0x1e80, 0x1f80, 0x2080, (char) 0xa180, (char) 0x8000, 0x0000, 0x0000, 0x0000, 0x0000 },
			new byte[] { (byte) 0x1b, (byte) 0x80, (byte) 0x1c, (byte) 0x80, (byte) 0x1d, (byte) 0x80, (byte) 0x1e, (byte) 0x80, (byte) 0x1f, (byte) 0x80, (byte) 0x20, (byte) 0x80, (byte) 0xa1, (byte) 0x80, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00},
	
			// 15 static final byte[] B1226 =
			new byte[] { (byte) 0x4e, (byte) 0x1d, (byte) 0xdb, (byte) 0x0a, (byte) 0xa8, (byte) 0x36, (byte) 0x34, (byte) 0x22, (byte) 0x00 },

			// static final char[] W1235 =
			// new char[] { 0x0000, 0x9b20, 0x19e0, 0x18a0, 0x1760, 0x1620, 0x14e0, 0x13a0, 0x1260, 0x1120, 0x0fe0, 0x0ea0 },
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x9b, (byte) 0x20, (byte) 0x19, (byte) 0xe0, (byte) 0x18, (byte) 0xa0, (byte) 0x17, (byte) 0x60, (byte) 0x16, (byte) 0x20, (byte) 0x14, (byte) 0xe0, (byte) 0x13, (byte) 0xa0, (byte) 0x12, (byte) 0x60, (byte) 0x11, (byte) 0x20, (byte) 0x0f, (byte) 0xe0, (byte) 0x0e, (byte) 0xa0},
			
			// static final byte[] B1259 =
			new byte[] { (byte) 0x48, (byte) 0x27, (byte) 0x26, (byte) 0x35, (byte) 0x44, (byte) 0x63, (byte) 0x13, (byte) 0x42, (byte) 0x71, (byte) 0x21, (byte) 0x50, (byte) 0x00 },

			// static final byte[] B1271 =
			new byte[] { (byte) 0x13, (byte) 0x03, (byte) 0x62, (byte) 0x42, (byte) 0x22, (byte) 0x02, (byte) 0x51, (byte) 0x21, (byte) 0xe0, (byte) 0x80 },

			// 19 static final byte[] B1281 =
			new byte[] { (byte) 0x05, (byte) 0x05, (byte) 0x85, (byte) 0x00, (byte) 0x00, (byte) 0x85, (byte) 0x05, (byte) 0x05, (byte) 0x05 },

			// 20 static final byte[] B1290 =
			new byte[] { (byte) 0x32, (byte) 0x22, (byte) 0x02, (byte) 0x61, (byte) 0x41, (byte) 0x21, (byte) 0x70, (byte) 0x40, (byte) 0xa0, (byte) 0x80 },

			// static final byte[] B1300 =
			new byte[] { (byte) 0x00, (byte) 0x40, (byte) 0x01, (byte) 0x41, (byte) 0x02, (byte) 0x42, (byte) 0x03, (byte) 0x33, (byte) 0x63 },

			// static final byte[] B1309 =
			new byte[] { (byte) 0x00, (byte) 0x20, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30 },

			// static final byte[] B1319 =
			new byte[] { (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1329 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x90, (byte) 0xb0 },

			// 25 static final byte[] B1338 =
			new byte[] { (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0xa0, (byte) 0x80 },

			// static final byte[] B1347 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x90, (byte) 0xb0 },

			// static final byte[] B1357 =
			new byte[] { (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0x30, (byte) 0xa0, (byte) 0x80 },

			// static final byte[] B1367 =
			new byte[] { (byte) 0x00, (byte) 0x21, (byte) 0x42, (byte) 0x53, (byte) 0xe4, (byte) 0x65, (byte) 0xe6, (byte) 0x57, (byte) 0x48 },

			// 29 static final byte[] B1376 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x41, (byte) 0x92, (byte) 0x62, (byte) 0xa3, (byte) 0x63, (byte) 0x14, (byte) 0x44 },

			// 30 static final byte[] B1385 =
			new byte[] { (byte) 0x00, (byte) 0x20, (byte) 0x40, (byte) 0xd0, (byte) 0x60, (byte) 0x60, (byte) 0xd0, (byte) 0x40, (byte) 0x20 },

			// static final byte[] B1394 =
			new byte[] { (byte) 0x04, (byte) 0x63, (byte) 0xb3, (byte) 0x03, (byte) 0x42, (byte) 0x82, (byte) 0x31, (byte) 0x60, (byte) 0x00 },

			// static final byte[] B1403 =
			new byte[] { (byte) 0xa6, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x35 },

			// static final byte[] B1412 =
			new byte[] { (byte) 0x47, (byte) 0x87, (byte) 0x46, (byte) 0x75, (byte) 0x25, (byte) 0x44, (byte) 0x63, (byte) 0x03, (byte) 0x22, (byte) 0x41, (byte) 0x60, (byte) 0x00 },

			// static final byte[] B1424 =
			new byte[] { (byte) 0x08, (byte) 0x27, (byte) 0x36, (byte) 0xc5, (byte) 0x44, (byte) 0x43, (byte) 0x32, (byte) 0x21, (byte) 0x00 },

			// 35 static final byte[] B1433 =
			new byte[] { (byte) 0x50, (byte) 0x50, (byte) 0x50, (byte) 0x50, (byte) 0xc0, (byte) 0x30, (byte) 0x20, (byte) 0x10, (byte) 0x00 },

			// static final byte[] B1442 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x11, (byte) 0x51, (byte) 0x22, (byte) 0x72 },

			// static final byte[] B1451 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x41, (byte) 0xa2, (byte) 0xd2, (byte) 0x62, (byte) 0xf2, (byte) 0x72, (byte) 0x72, (byte) 0x72, (byte) 0x72, (byte) 0x72 },

			// static final byte[] B1463 =
			new byte[] { (byte) 0x22, (byte) 0xb2, (byte) 0x32, (byte) 0xa2, (byte) 0x12, (byte) 0xf1, (byte) 0x31, (byte) 0x60, (byte) 0x00 },

			// 39 static final byte[] B1472 =
			new byte[] { (byte) 0x0a, (byte) 0x68, (byte) 0x47, (byte) 0x26, (byte) 0x05, (byte) 0x63, (byte) 0x42, (byte) 0x21, (byte) 0x00 },

			// 40 static final byte[] B1481 =
			new byte[] { (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21, (byte) 0x71, (byte) 0x42, (byte) 0x13, (byte) 0x63, (byte) 0x34, (byte) 0x05, (byte) 0x55 },

			// static final byte[] B1493 =
			new byte[] { (byte) 0x55, (byte) 0x26, (byte) 0x76, (byte) 0x47, (byte) 0x18, (byte) 0x68, (byte) 0x39, (byte) 0x8a, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1505 =
			new byte[] { (byte) 0x00, (byte) 0xc7, (byte) 0x76, (byte) 0x26, (byte) 0x55, (byte) 0x05, (byte) 0x34, (byte) 0x63, (byte) 0x13, (byte) 0x42, (byte) 0x71, (byte) 0x21 },

			// static final byte[] B1517 =
			new byte[] { (byte) 0x21, (byte) 0x60, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1529 =
			new byte[] { (byte) 0x8a, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x4c },

			// 45 static final byte[] B1538 =
			new byte[] { (byte) 0x00, (byte) 0x41, (byte) 0x03, (byte) 0x44, (byte) 0x06, (byte) 0x47, (byte) 0x09, (byte) 0x4a, (byte) 0x0c },

			// static final byte[] B1547 =
			new byte[] { (byte) 0x70, (byte) 0x50, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x50, (byte) 0x70 },

			// static final byte[] B1556 =
			new byte[] { (byte) 0xaa, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x2a },

			// static final byte[] B1565 =
			new byte[] { (byte) 0x59, (byte) 0x49, (byte) 0x39, (byte) 0xa9, (byte) 0x63, (byte) 0x63, (byte) 0x63, (byte) 0x63, (byte) 0x47 },

			// 49 static final byte[] B1574 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x50, (byte) 0x01, (byte) 0x31, (byte) 0x71, (byte) 0x42, (byte) 0x23, (byte) 0x14 },

			// 50 static final byte[] B1586 =
			new byte[] { (byte) 0x62, (byte) 0x62, (byte) 0x62, (byte) 0xd2, (byte) 0x42, (byte) 0xa2, (byte) 0x02, (byte) 0x61, (byte) 0xb1, (byte) 0x01, (byte) 0x40, (byte) 0x00 },

			// static final byte[] B1598 =
			new byte[] { (byte) 0x00, (byte) 0x40, (byte) 0x01, (byte) 0x41, (byte) 0x02, (byte) 0x42, (byte) 0x03, (byte) 0x43, (byte) 0x04, (byte) 0x64, (byte) 0x45, (byte) 0x26, (byte) 0x07, (byte) 0x67 },

			// static final byte[] B1612 =
			new byte[] { (byte) 0x00, (byte) 0x10, (byte) 0x20, (byte) 0x30, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x40 },

			// static final byte[] B1622 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21 },

			// static final byte[] B1631 =
			new byte[] { (byte) 0x8d, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// 55 static final char[] W1640 =
			// new char[] { 0x0000, 0x0000, 0x8000, 0x9c80, 0x1c80, 0x9c80, 0x8000, 0x0000, 0x0000 },
			new byte[] {  (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x00, (byte) 0x9c, (byte) 0x80, (byte) 0x1c, (byte) 0x80, (byte) 0x9c, (byte) 0x80, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1658 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x20, (byte) 0x40, (byte) 0x60, (byte) 0x01, (byte) 0x31, (byte) 0x71 },

			// static final byte[] B1667 =
			new byte[] { (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x70, (byte) 0x31, (byte) 0x71, (byte) 0xb2, (byte) 0x52, (byte) 0x62 },

			// static final byte[] B1676 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21, (byte) 0x02, (byte) 0x03 },

			// 59 static final byte[] B1685 =
			new byte[] { (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21, (byte) 0x71, (byte) 0x62, (byte) 0x53, (byte) 0x44 },

			// 60 static final byte[] B1694 =
			new byte[] { (byte) 0x00, (byte) 0x70, (byte) 0x61, (byte) 0x52, (byte) 0x43, (byte) 0x34, (byte) 0x25, (byte) 0x16, (byte) 0x07 },

			// static final byte[] B1703 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x2e },

			// static final byte[] B1712 =
			new byte[] { (byte) 0x00, (byte) 0x01, (byte) 0xf1, (byte) 0x52, (byte) 0xa3, (byte) 0x63, (byte) 0x94, (byte) 0x34, (byte) 0x54 },

			// static final byte[] B1721 =
			new byte[] { (byte) 0x00, (byte) 0x30, (byte) 0xd0, (byte) 0x70, (byte) 0x11, (byte) 0xa1, (byte) 0x31, (byte) 0x41, (byte) 0x41, (byte) 0x41 },

			// static final byte[] B1731 =
			new byte[] { (byte) 0x40, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x40, (byte) 0x11, (byte) 0x61 },

			// 65 static final byte[] B1740 =
			new byte[] { (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x40, (byte) 0x30, (byte) 0x20, (byte) 0x10, (byte) 0x00 },

			// static final char[] W1750 =
			// new char[] { 0x9ac0, 0x8000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x8000, 0x0c80 },
			new byte[] {  (byte) 0x9a, (byte) 0xc0, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00,  (byte) 0x80, (byte) 0x00, (byte) 0x0c, (byte) 0x80 },

			// static final byte[] B1768 =
			new byte[] { (byte) 0x24, (byte) 0x03, (byte) 0x02, (byte) 0x21, (byte) 0x60, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1777 =
			new byte[] { (byte) 0x47, (byte) 0x46, (byte) 0x65, (byte) 0x25, (byte) 0x05, (byte) 0x05, (byte) 0x15, (byte) 0x35, (byte) 0x75 },

			// 69 static final byte[] B1786 =
			new byte[] { (byte) 0x80, (byte) 0xe6, (byte) 0x16, (byte) 0x45, (byte) 0x74, (byte) 0x24, (byte) 0x53, (byte) 0x23, (byte) 0x13 },

			// 70 static final byte[] B1795 =
			new byte[] { (byte) 0x46, (byte) 0x25, (byte) 0x14, (byte) 0x13, (byte) 0x22, (byte) 0x41, (byte) 0x70, (byte) 0x30, (byte) 0x00 },

			// static final byte[] B1804 =
			new byte[] { (byte) 0x00, (byte) 0x01, (byte) 0x12, (byte) 0x33, (byte) 0x54, (byte) 0x75, (byte) 0x17, (byte) 0x38, (byte) 0x59, (byte) 0x7a },

			// static final byte[] B1814 =
			new byte[] { (byte) 0x02, (byte) 0x71, (byte) 0xd1, (byte) 0x21, (byte) 0x60, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1823 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21, (byte) 0xd1, (byte) 0x71, (byte) 0x02 },

			// static final byte[] B1832 =
			new byte[] { (byte) 0x00, (byte) 0x40, (byte) 0x81, (byte) 0x31, (byte) 0xd1, (byte) 0x61, (byte) 0xf1, (byte) 0x71, (byte) 0x71 },

			// 75 static final byte[] B1841 =
			new byte[] { (byte) 0x22, (byte) 0x61, (byte) 0x21, (byte) 0x60, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B1850 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x41, (byte) 0x22, (byte) 0x03, (byte) 0x63, (byte) 0x44, (byte) 0x25, (byte) 0x06, (byte) 0x66, (byte) 0x47, (byte) 0x28 },

			// static final byte[] B1862 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21, (byte) 0x71, (byte) 0x52, (byte) 0x43 },

			// static final byte[] B1871 =
			new byte[] { (byte) 0x24, (byte) 0x45, (byte) 0xe6, (byte) 0x80, (byte) 0x21, (byte) 0x42, (byte) 0x63, (byte) 0x05, (byte) 0x26 },

			// 79 static final char[] W1880 =
			// new char[] { 0x2860, 0x27c0, 0x2740, 0x26e0, 0x26a0, 0x2680, 0x2680, 0x26a0, 0x26e0, 0x2720, 0xa760, 0x0000 },
			new byte[] { (byte) 0x28, (byte) 0x60, (byte) 0x27, (byte) 0xc0, (byte) 0x27, (byte) 0x40, (byte) 0x26, (byte) 0xe0, (byte) 0x26, (byte) 0xa0, (byte) 0x26, (byte) 0x80, (byte) 0x26, (byte) 0x80, (byte) 0x26, (byte) 0xa0, (byte) 0x26, (byte) 0xe0, (byte) 0x27, (byte) 0x20, (byte) 0xa7, (byte) 0x60, (byte) 0x00, (byte) 0x00},

			// 80 static final byte[] B1904 =
			new byte[] { (byte) 0x00, (byte) 0x01, (byte) 0x02, (byte) 0x03, (byte) 0x04, (byte) 0x05, (byte) 0x06, (byte) 0x07, (byte) 0x08, (byte) 0x68, (byte) 0x49, (byte) 0x2a, (byte) 0x0b, (byte) 0x6b },

			null,

			// static final byte[] B1918 =
			new byte[] { (byte) 0x00, (byte) 0x70, (byte) 0x51, (byte) 0x32, (byte) 0x13, (byte) 0x73, (byte) 0x54, (byte) 0x35, (byte) 0x06 },

			// static final byte[] B1927 =
			new byte[] { (byte) 0x00, (byte) 0x50, (byte) 0x31, (byte) 0x12, (byte) 0x72, (byte) 0x53, (byte) 0x34, (byte) 0x15, (byte) 0x06 },

			// static final byte[] B1936 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x41, (byte) 0x22, (byte) 0x03, (byte) 0x73, (byte) 0x64, (byte) 0x65, (byte) 0x66, (byte) 0x67, (byte) 0x68, (byte) 0x69, (byte) 0x6a, (byte) 0x6b },

			// 85 static final byte[] B1950 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x41, (byte) 0x22, (byte) 0x03, (byte) 0x53, (byte) 0x24, (byte) 0x64, (byte) 0x25, (byte) 0x65, (byte) 0x26, (byte) 0x66, (byte) 0x27, (byte) 0x67 },

			// static final byte[] B1964 =
			new byte[] { (byte) 0x00, (byte) 0x81, (byte) 0x61, (byte) 0xa2, (byte) 0x42, (byte) 0x52, (byte) 0x52, (byte) 0x52, (byte) 0x52 },

			// static final byte[] B1973 =
			new byte[] { (byte) 0x00, (byte) 0x41, (byte) 0x72, (byte) 0x14, (byte) 0x35, (byte) 0x56, (byte) 0x77, (byte) 0x19, (byte) 0x3a, (byte) 0x5b },

			// static final byte[] B1983 =
			new byte[] { (byte) 0x00, (byte) 0x21, (byte) 0x42, (byte) 0x63, (byte) 0x05, (byte) 0x26, (byte) 0x47, (byte) 0x68, (byte) 0x1a, (byte) 0x5b },

			// 89 static final byte[] B1993 =
			new byte[] { (byte) 0x64, (byte) 0x14, (byte) 0x43, (byte) 0x72, (byte) 0x22, (byte) 0x51, (byte) 0x01, (byte) 0x40, (byte) 0x20, (byte) 0x10, (byte) 0x00, (byte) 0x00 },

			// 90 static final byte[] B2005 =
			new byte[] { (byte) 0x05, (byte) 0x05, (byte) 0x05, (byte) 0x15, (byte) 0x25, (byte) 0x45, (byte) 0xe5, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B2014 =
			new byte[] { (byte) 0x22, (byte) 0x12, (byte) 0xf1, (byte) 0x51, (byte) 0x31, (byte) 0x11, (byte) 0x60, (byte) 0x30, (byte) 0x00 },

			// static final byte[] B2023 =
			new byte[] { (byte) 0x00, (byte) 0x50, (byte) 0x31, (byte) 0x22, (byte) 0x23, (byte) 0x34, (byte) 0x55, (byte) 0x76, (byte) 0x18 },

			// static final byte[] B2032 =
			new byte[] { (byte) 0x00, (byte) 0x21, (byte) 0x42, (byte) 0x63, (byte) 0x05, (byte) 0x26, (byte) 0x47, (byte) 0x68, (byte) 0x79, (byte) 0x7a },

			// static final byte[] B2042 =
			new byte[] { (byte) 0x52, (byte) 0x71, (byte) 0x21, (byte) 0x60, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// 95 18 bytes static final char[] W2051 =
			// new char[] { 0x0000, 0x0020, 0x0040, 0x0060, 0x3200, 0x0060, 0x0040, 0x0020, 0x0000 },
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x60, (byte) 0x32, (byte) 0x00, (byte) 0x00, (byte) 0x60, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x00 },
			
			// 96, 18 bytes, draw bridge moving piece, +2 +3 static final char[] W2069 =
			// new char[] { 0x0000, 0x0020, 0x0040, 0x0060, 0x3200, 0x0060, 0x0040, 0x0020, 0x0000 },
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x60, (byte) 0x32, (byte) 0x00, (byte) 0x00, (byte) 0x60, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x00},
			
			// 18 bytes static final char[] W2087 =
			// new char[] { 0x0000, 0x0020, 0x0040, 0x0060, 0x3200, 0x0060, 0x0040, 0x0020, 0x0000 },
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x60, (byte) 0x32, (byte) 0x00, (byte) 0x00, (byte) 0x60, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x00},

			// 18 bytes static final char[] W2105 =
			// new char[] { 0x0000, 0x0020, 0x0040, 0x0060, 0x3200, 0x0060, 0x0040, 0x0020, 0x0000 },
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x60, (byte) 0x32, (byte) 0x00, (byte) 0x00, (byte) 0x60, (byte) 0x00, (byte) 0x40, (byte) 0x00, (byte) 0x20, (byte) 0x00, (byte) 0x00},
			
			// 99, 9 bytes (+54 for 95 piece) static final byte[] B2123 =
			new byte[] { (byte) 0x63, (byte) 0x43, (byte) 0xa3, (byte) 0xf2, (byte) 0x42, (byte) 0x02, (byte) 0x41, (byte) 0x01, (byte) 0x40 },

			// 100, 12 bytes (+63 for 95 piece) static final byte[] B2132 =
			new byte[] { (byte) 0x28, (byte) 0x47, (byte) 0x66, (byte) 0x06, (byte) 0x25, (byte) 0x44, (byte) 0x63, (byte) 0x03, (byte) 0x22, (byte) 0x41, (byte) 0x60, (byte) 0x00 },

			// 10 bytes (+75 for 95 piece) static final byte[] B2144 =
			new byte[] { (byte) 0x14, (byte) 0x73, (byte) 0x43, (byte) 0x03, (byte) 0x42, (byte) 0x02, (byte) 0x41, (byte) 0x01, (byte) 0x40, (byte) 0x00 },

			// 10 bytes static final byte[] B2154 =
			new byte[] { (byte) 0x74, (byte) 0x14, (byte) 0x43, (byte) 0x03, (byte) 0x42, (byte) 0x02, (byte) 0x41, (byte) 0x01, (byte) 0x40, (byte) 0x00 },

			// 10 bytes static final byte[] B2164 =
			new byte[] { (byte) 0x14, (byte) 0x53, (byte) 0x13, (byte) 0x52, (byte) 0x12, (byte) 0x51, (byte) 0x11, (byte) 0x50, (byte) 0xa0, (byte) 0x80 },

			// 10 bytes static final byte[] B2174 =
			new byte[] { (byte) 0x74, (byte) 0x34, (byte) 0x73, (byte) 0x33, (byte) 0x72, (byte) 0x32, (byte) 0x71, (byte) 0x31, (byte) 0xe0, (byte) 0x80 },

			// 9 bytes static final byte[] B2184 =
			new byte[] { (byte) 0x23, (byte) 0x62, (byte) 0x22, (byte) 0x61, (byte) 0x21, (byte) 0x70, (byte) 0x40, (byte) 0x20, (byte) 0x00 },

			// 9 bytes static final byte[] B2193 =
			new byte[] { (byte) 0x42, (byte) 0x42, (byte) 0x52, (byte) 0x72, (byte) 0x13, (byte) 0x43, (byte) 0xf3, (byte) 0x80, (byte) 0x00 },

			// 9 bytes static final byte[] B2202 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x85, (byte) 0x05, (byte) 0x05, (byte) 0x05, (byte) 0x05 },

			// 9 bytes static final byte[] B2211 =
			new byte[] { (byte) 0x0c, (byte) 0x59, (byte) 0x47, (byte) 0x55, (byte) 0x04, (byte) 0x52, (byte) 0x41, (byte) 0x50, (byte) 0x00 },

			// 109, 9 bytes static final byte[] B2220 =
			new byte[] { (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x50, (byte) 0xe0, (byte) 0x50, (byte) 0x30, (byte) 0x10, (byte) 0x00 },

			// 110 static final byte[] B2229 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x80, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00 },

			// static final byte[] B2238 =
			new byte[] { (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x04, (byte) 0x73, (byte) 0xe3, (byte) 0x33, (byte) 0x52, (byte) 0x41, (byte) 0x00 },

			// static final byte[] B2250 =
			new byte[] { (byte) 0x44, (byte) 0x04, (byte) 0x43, (byte) 0x03, (byte) 0x42, (byte) 0x02, (byte) 0x41, (byte) 0x01, (byte) 0x40, (byte) 0x00 },

			// static final byte[] B2260 =
			new byte[] { (byte) 0x41, (byte) 0x41, (byte) 0x41, (byte) 0x41, (byte) 0x41, (byte) 0x41, (byte) 0x31, (byte) 0xa1, (byte) 0x01, (byte) 0xe0, (byte) 0x30, (byte) 0x00 },

			// static final char[] W2272 =
			// new char[] { 0x18c0, 0x1680, 0x1440, 0x1200, 0x0fc0, 0x0d80, 0x0b40, 0x0900, 0x06c0, 0x0480, 0x0240, 0x0000 },
			new byte[] {  (byte) 0x18, (byte) 0xc0, (byte) 0x16, (byte) 0x80, (byte) 0x14, (byte) 0x40, (byte) 0x12, (byte) 0x00, (byte) 0x0f, (byte) 0xc0, (byte) 0x0d, (byte) 0x80, (byte) 0x0b, (byte) 0x40, (byte) 0x09, (byte) 0x00, (byte) 0x06, (byte) 0xc0, (byte) 0x04, (byte) 0x80, (byte) 0x02, (byte) 0x40, (byte) 0x00, (byte) 0x00},
			
			// static final byte[] B2296 =
			new byte[] { (byte) 0x7e, (byte) 0x4c, (byte) 0x1a, (byte) 0x08, (byte) 0x16, (byte) 0x44, (byte) 0x13, (byte) 0x02, (byte) 0x11, (byte) 0x40, (byte) 0x10, (byte) 0x00 },

			// static final byte[] B2308 =
			new byte[] { (byte) 0x60, (byte) 0x30, (byte) 0x10, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21 },

			// static final char[] W2317 =
			// new char[] { 0x1300, 0x10a0, 0x0e40, 0x0be0, 0x0980, 0x0720, 0x04c0, 0x0260, 0x0000 },
			new byte[] {  (byte) 0x13, (byte) 0x00, (byte) 0x10, (byte) 0xa0, (byte) 0x0e, (byte) 0x40, (byte) 0x0b, (byte) 0xe0, (byte) 0x09, (byte) 0x80, (byte) 0x07, (byte) 0x20, (byte) 0x04, (byte) 0xc0, (byte) 0x02, (byte) 0x60, (byte) 0x00, (byte) 0x00},
			
			// static final byte[] B2335 =
			new byte[] { (byte) 0x00, (byte) 0xe8, (byte) 0x18, (byte) 0x47, (byte) 0x76, (byte) 0x26, (byte) 0x55, (byte) 0x05, (byte) 0x34 },

			// 119 static final byte[] B2344 =
			new byte[] { (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x10, (byte) 0x30, (byte) 0x60, (byte) 0x21, (byte) 0x71, (byte) 0x42 },

			// 120, 121
			null, null,

			// static final byte[] B2353 = 
			new byte[] { (byte) 0x00, (byte) 0x21, (byte) 0x42, (byte) 0x63, (byte) 0x05, (byte) 0x26, (byte) 0x47, (byte) 0x68, (byte) 0x0a },

			null,

			// static final byte[] B2362 =
			new byte[] { (byte) 0x00, (byte) 0x60, (byte) 0x31, (byte) 0x71, (byte) 0x32, (byte) 0x72, (byte) 0x33, (byte) 0x73, (byte) 0x34, (byte) 0x74 },

			// static final byte[] B2372 =
			new byte[] { (byte) 0x00, (byte) 0x20, (byte) 0x50, (byte) 0x11, (byte) 0x51, (byte) 0x12, (byte) 0x52, (byte) 0x13, (byte) 0x53, (byte) 0x14 },

			// static final byte[] B2382 =
			new byte[] { (byte) 0x00, (byte) 0x40, (byte) 0x01, (byte) 0x41, (byte) 0x02, (byte) 0x42, (byte) 0x03, (byte) 0x43, (byte) 0x94, (byte) 0xf4 },

			// 127 static final byte[] B2392 =
			new byte[] { (byte) 0x00, (byte) 0x40, (byte) 0x01, (byte) 0x41, (byte) 0x02, (byte) 0x42, (byte) 0x03, (byte) 0x43, (byte) 0xf3, (byte) 0x94 },
	};

	static int getCoordinateAsByte(final byte[] b, final int offset) {
		final int v = b[ offset ];
		return (((v & 0x0F) << 8) | ((v << 1) & 0xE0));
	}

	/**
	 * Get unsigned data stored in the big endian format
	 *
	 * @param b an array
	 * @param offset offset
	 * @return an unsigned ui16
	 */
	static int getCoordinateAsWord(final byte[] b, final int offset) {
		return (((b[ offset ] & 0x7F) << 8) | (b[ offset + 1 ] & 0xFF));
	}

	/**
	 * Get signed data stored in the low endian format
	 *
	 * @param b a piece
	 * @param offset offset in bytes
	 * @return a signed i16
	 */
	static int getSignedWordDataFromPiece(final byte[] b, final int offset) {
		return (((b[ offset + 1 ]) << 8) | (b[ offset ] & 0xFF));
	}
	
	/** The words give the following offsets :
	 *
	 *	1037,1051,1060,1078,1092,1106,1116,1126
	 *	1135,1144,1158,1172,1181,1190,1202,1226
	 *	1235,1259,1271,1281,1290,1300,1309,1319
	 *	1329,1338,1347,1357,1367,1376,1385,1394
	 *	1403,1412,1424,1433,1442,1451,1463,1472
	 *	1481,1493,1505,1517,1529,1538,1547,1556
	 *	1565,1574,1586,1598,1612,1622,1631,1640
	 *	1658,1667,1676,1685,1694,1703,1712,1721
	 *	1731,1740,1750,1768,1777,1786,1795,1804
	 *	1814,1823,1832,1841,1850,1862,1871,1880
	 *	1904,0000,1918,1927,1936,1950,1964,1973
	 *	1983,1993,2005,2014,2023,2032,2042,2051
	 *	2069,2087,2105,2123,2132,2144,2154,2164
	 *	2174,2184,2193,2202,2211,2220,2229,2238
	 *	2250,2260,2272,2296,2308,2317,2335,2344
	 *	0000,0000,2353,0000,2362,2372,2382,2392
	 */
	/* static final short[] w_y_coordinate_offsets = {
			0x0db5, 0x1bb5, 0x24b5, 0x36b5, 0x44b5, 0x52b5, 0x5cb5, 0x66b5,
			0x6fb5, 0x78b5, (short)0x86b5, (short)0x94b5, (short)0x9db5, (short)0xa6b5, (short)0xb2b5, (short)0xcab5,
			(short)0xd3b5, (short)0xebb5, (short)0xf7b5, 0x01b6, 0x0ab6, 0x14b6, 0x1db6, 0x27b6,
			0x31b6, 0x3ab6, 0x43b6, 0x4db6, 0x57b6, 0x60b6, 0x69b6, 0x72b6,
			0x7bb6, (short)0x84b6, (short)0x90b6, (short)0x99b6, (short)0xa2b6, (short)0xabb6, (short)0xb7b6, (short)0xc0b6,
			(short)0xc9b6, (short)0xd5b6, (short)0xe1b6, (short)0xedb6, (short)0xf9b6, 0x02b7, 0x0bb7, 0x14b7,
			0x1db7, 0x26b7, 0x32b7, 0x3eb7, 0x4cb7, 0x56b7, 0x5fb7, 0x68b7,
			0x7ab7, (short)0x83b7, (short)0x8cb7, (short)0x95b7, (short)0x9eb7, (short)0xa7b7, (short)0xb0b7, (short)0xb9b7,
			(short)0xc3b7, (short)0xccb7, (short)0xd6b7, (short)0xe8b7, (short)0xf1b7, (short)0xfab7, 0x03b8, 0x0cb8,
			0x16b8, 0x1fb8, 0x28b8, 0x31b8, 0x3ab8, 0x46b8, 0x4fb8, 0x58b8,
			0x70b8, (short)0xa720, 0x7eb8, (short)0x87b8, (short)0x90b8, (short)0x9eb8, (short)0xacb8, (short)0xb5b8,
			(short)0xbfb8, (short)0xc9b8, (short)0xd5b8, (short)0xdeb8, (short)0xe7b8, (short)0xf0b8, (short)0xfab8, 0x03b9,
			0x15b9, 0x27b9, 0x39b9, 0x4bb9, 0x54b9, 0x60b9, 0x6ab9, 0x74b9,
			0x7eb9, (short)0x88b9, (short)0x91b9, (short)0x9ab9, (short)0xa3b9, (short)0xacb9, (short)0xb5b9, (short)0xbeb9,
			(short)0xcab9, (short)0xd4b9, (short)0xe0b9, (short)0xf8b9, 0x04ba, 0x0dba, 0x1fba, 0x28ba,
			(short)0xa320, 0x7da3, 0x31ba, (short)0xaa20, 0x3aba, 0x44ba, 0x4eba, 0x58ba
	}; */
	
	/** opponents.x.spans, 32 values, 0...27 */
	static final byte[] opponents_x_spans = {
			27, 27, 27, 27, 27, 26, 26, 26, 25, 25, 25, 24, 23, 23, 22, 21,
			20, 19, 18, 17, 15, 14, 11, 9, 7, 7, 7, 7, 7, 7, 7, 7
		};

	/** Draw bridge */
	static final byte[] b_draw_bridge_speed_values = {
			(byte)0xd2, (byte)0xbb, (byte)0xb7, (byte)0xb3,
			(byte)0xb1, (byte)0xad, (byte)0xab, (byte)0xa7,
			(byte)0xa6, (byte)0xa4, (byte)0xa2, (byte)0xa1,
			(byte)0x9f, (byte)0x9f, (byte)0x9f, (byte)0x9e
		};

	static final byte[] b_draw_bridge_opponents_speed_changes = {
			(byte)0xf7, (byte)0xf7, (byte)0xf6, (byte)0xf6,
			(byte)0xf5, (byte)0xf5, (byte)0xf6, (byte)0xf7,
			(byte)0xf8, (byte)0xf9, (byte)0xfb, (byte)0xfd,
			(byte)0xff, 0x02, 0x05, (byte)0xfd
		};

	// road.steering.changes
	static final short[] w_road_steering_changes = {
			0,//	for straight road
			217,//	for curve to right
			-217,//	for curve to left
	};

	/*
	 * for Java
	 *
	 * @param offset offset
	 * @return a unsigned byte array
	 */
	/* static byte[] offsetToRoad(final int offset) {
		switch( offset ) {
			default:
				System.err.println( "Incorrect offset for road: " + offset );
				return new byte[ 0 ];
			case 2402:
				return Road.LittleRamp;

			case 2526:
				return Road.SteppingStones;

			case 2671:
				return Road.HumpBack;

			case 2816:
				return Road.BigRamp;

			case 2958:
				return Road.SkiJump;

			case 3103:
				return Road.DrawBridge;

			case 3316:
				return Road.HighJump;

			case 3458:
				return Road.RollerCoaster;

		}
	} */

	/*
	 * for Java
	 *
	 * @param offset offset
	 * @return a unsigned byte array
	 */
	/* static byte[] offsetToPiece(final int offset) {
		switch( offset ) {
			default:
				System.err.println( "Incorrect offset for piece: " + offset );
				return new byte[ 0 ];
			case 336:
				return Road.piece1;

			case 419:
				return Road.piece2;

			case 510:
				return Road.piece3;

			case 601:
				return Road.piece4;

			case 728:
				return Road.piece5;

			case 827:
				return Road.piece6;

			case 926:
				return Road.piece7;

		}
	} */

	/*
	 * for Java
	 *
	 * @param offset offset for 'B'
	 * @return a unsigned byte array
	 */
	/* static byte[] offsetToNearPieceYdataBytes(final int offset) {
		try {
			return (byte[]) Road.class.getDeclaredField( "B" + offset ).get( null );
		} catch(final Exception e) {
			e.printStackTrace();
			System.err.printf("incorrect offset for offsetToBytePiece: %s%n", offset );
			return new byte[ 0 ];
		}
	} */

	/*
	 * for Java
	 *
	 * @param offset offset for 'W'
	 * @return a unsigned byte array
	 */
	/* static char[] offsetToNearPieceYdataWords(final int offset) {
		try {
			return (char[]) Road.class.getDeclaredField( "W" + offset ).get( null );
		} catch(final Exception e) {
			e.printStackTrace();
			System.err.printf("incorrect offset for offsetToWordPiece: %s%n", offset );
			return new char[ 0 ];
		}
	} */
}
